"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _core = require("@dubstep/core");

var _shared = require("./shared.js");

/*
Copyright (c) 2018-2019 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
const FLOW_IGNORE = '$FlowFixMe';

async function styledV7FlowFixme(options) {
  await (0, _core.withJsFiles)(`${options.dir}/**/*.js`, async p => {
    if ((0, _shared.containsFlowComment)(p)) {
      const styledLocalImportName = (0, _shared.getStyledLocalImportName)(p);

      if (styledLocalImportName) {
        p.traverse({
          CallExpression(path) {
            if (path.node.callee.name === styledLocalImportName && !path.node.typeArguments) {
              const parent = path.findParent(n => n.isVariableDeclaration());

              if (parent) {
                const comments = parent.node.comments || [];

                if (comments.every(c => !c.value.includes(FLOW_IGNORE))) {
                  comments.push({
                    type: 'CommentLine',
                    value: ' $FlowFixMe',
                    leading: true
                  });
                  parent.node.comments = comments;
                }
              }
            }
          }

        });
      }
    }
  });
}

var _default = styledV7FlowFixme;
exports.default = _default;